# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 11
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class WormDomainExclusion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'lin': 'int',
        'path': 'str'
    }

    attribute_map = {
        'id': 'id',
        'lin': 'lin',
        'path': 'path'
    }

    def __init__(self, id=None, lin=None, path=None):  # noqa: E501
        """WormDomainExclusion - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._lin = None
        self._path = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if lin is not None:
            self.lin = lin
        if path is not None:
            self.path = path

    @property
    def id(self):
        """Gets the id of this WormDomainExclusion.  # noqa: E501

        Specifies the system-assigned ID for the WORM exclusion domain.  # noqa: E501

        :return: The id of this WormDomainExclusion.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this WormDomainExclusion.

        Specifies the system-assigned ID for the WORM exclusion domain.  # noqa: E501

        :param id: The id of this WormDomainExclusion.  # noqa: E501
        :type: int
        """
        if id is not None and id > 9223372036854775807:  # noqa: E501
            raise ValueError("Invalid value for `id`, must be a value less than or equal to `9223372036854775807`")  # noqa: E501
        if id is not None and id < 0:  # noqa: E501
            raise ValueError("Invalid value for `id`, must be a value greater than or equal to `0`")  # noqa: E501

        self._id = id

    @property
    def lin(self):
        """Gets the lin of this WormDomainExclusion.  # noqa: E501

        Specifies the logical inode number (LIN) for the root of this domain.  # noqa: E501

        :return: The lin of this WormDomainExclusion.  # noqa: E501
        :rtype: int
        """
        return self._lin

    @lin.setter
    def lin(self, lin):
        """Sets the lin of this WormDomainExclusion.

        Specifies the logical inode number (LIN) for the root of this domain.  # noqa: E501

        :param lin: The lin of this WormDomainExclusion.  # noqa: E501
        :type: int
        """
        if lin is not None and lin > 9223372036854775807:  # noqa: E501
            raise ValueError("Invalid value for `lin`, must be a value less than or equal to `9223372036854775807`")  # noqa: E501
        if lin is not None and lin < 0:  # noqa: E501
            raise ValueError("Invalid value for `lin`, must be a value greater than or equal to `0`")  # noqa: E501

        self._lin = lin

    @property
    def path(self):
        """Gets the path of this WormDomainExclusion.  # noqa: E501

        Specifies the root path of this domain. Files in this directory and all sub-directories will not be protected.  # noqa: E501

        :return: The path of this WormDomainExclusion.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this WormDomainExclusion.

        Specifies the root path of this domain. Files in this directory and all sub-directories will not be protected.  # noqa: E501

        :param path: The path of this WormDomainExclusion.  # noqa: E501
        :type: str
        """
        if path is not None and len(path) > 4096:
            raise ValueError("Invalid value for `path`, length must be less than or equal to `4096`")  # noqa: E501
        if path is not None and len(path) < 1:
            raise ValueError("Invalid value for `path`, length must be greater than or equal to `1`")  # noqa: E501

        self._path = path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WormDomainExclusion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
